Bug 921847

Summary: Review Request: ycssmin - CSS minification tool
Product: [Fedora] Fedora Reporter: T.C. Hollingsworth <tchollingsworth>
Component: Package ReviewAssignee: Lokesh Mandvekar <lsm5>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: jamielinux, jkeck, lsm5, mrunge, notting, package-review
Target Milestone: ---Flags: lsm5: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: ycssmin-1.0.1-3.fc18 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-05-15 13:30:25 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 921365    

Description T.C. Hollingsworth 2013-03-15 02:14:52 EDT
Spec: http://patches.fedorapeople.org/node-misc/ycssmin.spec
SRPM: http://patches.fedorapeople.org/node-misc/ycssmin-1.0.1-1.fc18.src.rpm
Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5124803
FAS username: patches
Description:
ycssmin is a CSS minification tool.

It was originally based on the javascript for of the css minification tool used 
inside of YUICompressor based on code from Stoyan Stefanov and Isaac Schlueter.
Comment 1 T.C. Hollingsworth 2013-03-15 03:12:17 EDT
Sorry, noticed a typo in the symlink when testing out the updated less:
Comment 2 T.C. Hollingsworth 2013-03-15 03:12:53 EDT
Sorry, noticed a typo in the symlink when testing out the updated less:

Spec: http://patches.fedorapeople.org/node-misc/ycssmin.spec
SRPM: http://patches.fedorapeople.org/node-misc/ycssmin-1.0.1-2.fc18.src.rpm
Comment 3 Jamie Nguyen 2013-03-16 03:32:24 EDT
The %description needs a bit of work:
javascript->JavaScript
css->CSS
"for of"
And I think some commas are missing.

/usr/bin/cssmin could also do with a man page.



Right, so let me get this straight...

ycssmin is Yahoo's fork of Johan Bleuzen's node-cssmin, which is a fork of Stoyan Stefanov's cssmin.js, which is a JavaScript port of YUICompressor's cssmin utility, which is a Java port of Isaac Schlueter's cssmin.

Forks are fine but my only concern is that /usr/bin/cssmin may clash if somebody wants to package eg Johan's version. It does look like ycssmin is the most healthy project so we probably want to make it the "default" cssmin anyway.
Comment 4 T.C. Hollingsworth 2013-03-16 04:24:27 EDT
(In reply to comment #3)
> The %description needs a bit of work:
> javascript->JavaScript
> css->CSS
> "for of"
> And I think some commas are missing.

Sorry, that's obivously a bad README copy/paste job.  I'll do it justice soon.

> /usr/bin/cssmin could also do with a man page.

I have a to-do list of a couple man pages.  I was waiting for nodejs-ronn to get in so I could do them in Markdown.  I figure most nodejs upstreams will be happier with that than groff.  ;-)

> Right, so let me get this straight...
> 
> ycssmin is Yahoo's fork of Johan Bleuzen's node-cssmin, which is a fork of
> Stoyan Stefanov's cssmin.js, which is a JavaScript port of YUICompressor's
> cssmin utility, which is a Java port of Isaac Schlueter's cssmin.
> 
> Forks are fine but my only concern is that /usr/bin/cssmin may clash if
> somebody wants to package eg Johan's version. It does look like ycssmin is
> the most healthy project so we probably want to make it the "default" cssmin
> anyway.

I consdiered it more of an unfork of Johan's cssmin, the upstream for YUI Compressor just took back over the node fork.  YUI Compressor cssmin is written in JS too, it just bundles the Mozilla Rhino server-side JS engine.  Are you sure it was a fork of some izs cssmin?  I figured he just wrote the original YUI version (along with a fair chunk of the rest of YUI  ;-).
Comment 5 Jamie Nguyen 2013-03-16 17:51:12 EDT
> I have a to-do list of a couple man pages.  I was waiting
> for nodejs-ronn to get in so I could do them in Markdown.
> I figure most nodejs upstreams will be happier with that
> than groff.  ;-)

You have a point there! (Though having said that, of the package reviews I have at the moment, only one has a man page upstream and that's in groff.)


> I consdiered it more of an unfork of Johan's cssmin, the
> upstream for YUI Compressor just took back over the node
> fork.  YUI Compressor cssmin is written in JS too, it just
> bundles the Mozilla Rhino server-side JS engine.  Are you
> sure it was a fork of some izs cssmin?  I figured he just
> wrote the original YUI version (along with a fair chunk of
> the rest of YUI  ;-).

My previous comment reads more like a statement when it should really have had a question mark at the end. I'm not sure of anything in this fork chain, but I'm happy to believe whatever you tell me ;)
Comment 6 T.C. Hollingsworth 2013-03-18 19:51:33 EDT
(In reply to comment #5)
> You have a point there! (Though having said that, of the package reviews I
> have at the moment, only one has a man page upstream and that's in groff.)

FWIW, all of npm's manpages are written in markdown and are converted to groff using ronn.
Comment 7 Lokesh Mandvekar 2013-04-19 12:35:52 EDT
I'm still getting used to detailed reviewing, so please double-check if possible, and let me know if I messed something up. Thanks.


Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- License field in the package spec file matches the actual license.
  Note: Checking patched sources after %prep for licenses. No licenses found.
  Please check the source files for licenses manually.
  See: http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#ValidLicenseShortNames


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[?]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required

     Consider removing rm -rf %{buildroot}

[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[?]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[-]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[x]: Buildroot is not present
     Note: Buildroot: present but not needed
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ycssmin-1.0.1-2.fc20.noarch.rpm
ycssmin.noarch: W: spelling-error Summary(en_US) minification -> magnification, indemnification, mummification
ycssmin.noarch: W: spelling-error %description -l en_US minification -> magnification, indemnification, mummification
ycssmin.noarch: W: spelling-error %description -l en_US javascript -> java script, java-script, JavaScript
ycssmin.noarch: W: spelling-error %description -l en_US css -> cs, cuss, ass
ycssmin.noarch: W: only-non-binary-in-usr-lib
ycssmin.noarch: E: script-without-shebang /usr/lib/node_modules/ycssmin/package.json
ycssmin.noarch: E: script-without-shebang /usr/lib/node_modules/ycssmin/cssmin.js
ycssmin.noarch: W: no-manual-page-for-binary cssmin
1 packages and 0 specfiles checked; 2 errors, 6 warnings.

Add shebang or remove executable bits


Rpmlint (installed packages)
----------------------------
# rpmlint ycssmin
ycssmin.noarch: W: spelling-error Summary(en_US) minification -> magnification, indemnification, mummification
ycssmin.noarch: W: spelling-error %description -l en_US minification -> magnification, indemnification, mummification
ycssmin.noarch: W: spelling-error %description -l en_US javascript -> java script, java-script, JavaScript
ycssmin.noarch: W: spelling-error %description -l en_US css -> cs, cuss, ass
ycssmin.noarch: W: only-non-binary-in-usr-lib
ycssmin.noarch: E: script-without-shebang /usr/lib/node_modules/ycssmin/package.json
ycssmin.noarch: E: script-without-shebang /usr/lib/node_modules/ycssmin/cssmin.js
ycssmin.noarch: W: no-manual-page-for-binary cssmin
1 packages and 0 specfiles checked; 2 errors, 6 warnings.
# echo 'rpmlint-done:'

Add shebang or remove executable bits

Requires
--------
ycssmin (rpmlib, GLIBC filtered):
    /usr/bin/env
    nodejs(engine)

OK


Provides
--------
ycssmin:
    npm(ycssmin)
    ycssmin

OK



MD5-sum check
-------------
http://registry.npmjs.org/ycssmin/-/ycssmin-1.0.1.tgz :
  CHECKSUM(SHA256) this package     : 29a362b52718a16f7e8d06961645a6f2097bee372996f12f5c63a2412f10279f
  CHECKSUM(SHA256) upstream package : 29a362b52718a16f7e8d06961645a6f2097bee372996f12f5c63a2412f10279f

OK

Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 921847
Comment 8 T.C. Hollingsworth 2013-05-06 14:02:13 EDT
(In reply to comment #7)
> - License field in the package spec file matches the actual license.
>   Note: Checking patched sources after %prep for licenses. No licenses found.
>   Please check the source files for licenses manually.
>   See:
> http://fedoraproject.org/wiki/Packaging/
> LicensingGuidelines#ValidLicenseShortNames

LICENSE file contains BSD.

> [?]: Package contains no bundled libraries without FPC exception.

Not sure why this has a question mark; no libraries are bundled.

> [x]: Changelog in prescribed format.
> [!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
>      beginning of %install.
>      Note: rm -rf %{buildroot} present but not required
> 
>      Consider removing rm -rf %{buildroot}

I dropped the EL5isms from this package.

> [?]: Package requires other packages for directories it uses.

Not sure why this has a question mark; the only directory needed is %{nodejs_sitelib}, which is owned by nodejs, Requires on which are automatically added by the nodejs dep generator.

> [!]: Package has no %clean section with rm -rf %{buildroot} (or
>      $RPM_BUILD_ROOT)
>      Note: %clean present but not required

I dropped the EL5isms from this package, as indicated above.

> [x]: If the source package does not include license text(s) as a separate
> file
>      from upstream, the packager SHOULD query upstream to include it.
> [x]: Final provides and requires are sane (see attachments).
> [?]: Package functions as described.

It does.  ;-)

> [?]: Latest version is packaged.

%  npm view ycssmin version
npm http GET https://registry.npmjs.org/ycssmin
npm http 200 https://registry.npmjs.org/ycssmin
1.0.1

> Add shebang or remove executable bits

Fixed.

--

Spec: http://patches.fedorapeople.org/node-misc/ycssmin.spec
SRPM: http://patches.fedorapeople.org/node-misc/ycssmin-1.0.1-3.fc19.src.rpm

* Mon May 06 2013 T.C. Hollingsworth <tchollingsworth@gmail.com> - 1.0.1-3
- improve description
- drop spurious executable permissions
- drop EL5isms
Comment 9 Lokesh Mandvekar 2013-05-06 15:54:31 EDT
Thanks for addressing those points.

I'm approving this.
Comment 10 T.C. Hollingsworth 2013-05-06 15:57:34 EDT
Thanks, sorry it took me so long.  BTW, I believe you still have one open review assigned to me I'm waiting on a response to.

New Package SCM Request
=======================
Package Name: ycssmin
Short Description: CSS minification tool
Owners: patches sgallagh mrunge
Branches: f19 f18 el6
InitialCC:
Comment 11 Lokesh Mandvekar 2013-05-06 16:04:39 EDT
Yes, haven't had the time to work on it yet. Should be doing it over the next few days. Also, I should be able to review the other 2 packages you provided me links for, if they haven't been reviewed already.

Thanks.
Comment 12 T.C. Hollingsworth 2013-05-06 16:07:21 EDT
No worries.  :-)  

I already swapped the other two with someone else, but thanks!
Comment 13 Jon Ciesla 2013-05-06 16:12:03 EDT
Git done (by process-git-requests).
Comment 14 Fedora Update System 2013-05-06 18:36:49 EDT
ycssmin-1.0.1-3.fc18, nodejs-less-1.3.3-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ycssmin-1.0.1-3.fc18,nodejs-less-1.3.3-4.fc18
Comment 15 Fedora Update System 2013-05-06 18:37:00 EDT
ycssmin-1.0.1-3.fc19, nodejs-less-1.3.3-4.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ycssmin-1.0.1-3.fc19,nodejs-less-1.3.3-4.fc19
Comment 16 Fedora Update System 2013-05-06 18:37:42 EDT
ycssmin-1.0.1-3.fc18, nodejs-less-1.3.3-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ycssmin-1.0.1-3.fc18,nodejs-less-1.3.3-4.fc18
Comment 17 Fedora Update System 2013-05-07 16:47:05 EDT
Package ycssmin-1.0.1-3.fc19, nodejs-less-1.3.3-4.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing ycssmin-1.0.1-3.fc19 nodejs-less-1.3.3-4.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-7624/ycssmin-1.0.1-3.fc19,nodejs-less-1.3.3-4.fc19
then log in and leave karma (feedback).
Comment 18 Fedora Update System 2013-05-10 15:27:23 EDT
ycssmin-1.0.1-3.el6,nodejs-less-1.3.3-4.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/ycssmin-1.0.1-3.el6,nodejs-less-1.3.3-4.el6
Comment 19 Fedora Update System 2013-05-15 13:30:25 EDT
ycssmin-1.0.1-3.fc19, nodejs-less-1.3.3-4.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2013-05-29 13:33:03 EDT
ycssmin-1.0.1-3.el6, nodejs-less-1.3.3-4.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 21 Fedora Update System 2013-05-29 23:07:01 EDT
ycssmin-1.0.1-3.fc18, nodejs-less-1.3.3-4.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.